package org.mentawai.log;

import java.io.File;
import java.io.IOException;

import org.mentawai.core.ApplicationManager;

public class Debug {
	
	public static boolean ENABLED = false;
    
    public static String FILENAME = "DEBUG.LOG";
    
    private static Logger logger;
    
    static {
        
        try {
            
            boolean isConsole = Boolean.getBoolean("logConsole");
            
            if (isConsole) {
                
                logger = new SimpleLogger(System.err);
                
            } else {
            
                String filename = System.getProperty("logDebugFile", FILENAME);
                
                String dir = System.getProperty("logDir");
                
                if (dir == null) {
                	
                	dir = ApplicationManager.getRealPath();
                	
                	if (!dir.endsWith("/")) dir = dir + "/";
                	
                	dir = dir + "WEB-INF/logs";
                	
                	File theDir = new File(dir);
                	
                	if (!theDir.exists()) theDir.mkdir();
                }
            
                logger = new SimpleLogger(dir, filename);
                
            }
            
        } catch(Exception e) {
            
            System.err.println("Cannot open " + FILENAME + "!!!");
            
            e.printStackTrace();
            
            logger = null;
        }
    }
    
    public static void enable(boolean flag) {
        
        if (logger != null) {
        	
        	logger.enable(flag);
        	
        	ENABLED = flag;
        }
    }
    
    public static void roll() throws IOException {
        
        if (logger != null) logger.roll();
    }

    public static void log(String... msgs) {
        
        if (logger != null) logger.log(msgs);
    }
    
    public static void log(Object... objects) {
        
        if (logger != null) logger.log(objects);

    }
}