package org.mentawai.tag.util;

import java.io.IOException;

import javax.servlet.jsp.JspException;
import javax.servlet.jsp.tagext.BodyContent;

import org.mentawai.util.Regex;

public abstract class PrintBodyTag extends PrintTag {
	
	private boolean replaceAll = false;
	
	public void setReplaceAll(boolean flag) {
		this.replaceAll = flag;
	}
	
    private String getBody() {
    	
    	BodyContent bc = getBodyContent();
    	
    	if (bc != null) {
    		
    		String s = bc.getString();
    		
    		if (s != null) {
    			
    			s = s.trim();
    			
    			if (!s.equals("")) return s;
    		}
    	}
    	
    	return null;
    }

	
	@Override
    public int doEndTag() throws JspException {
		
        String s = getStringToPrint();
        
        String body = getBody();
        
    	if (body != null) {
    		
    		if (s.contains("/")) {
    			
    			s = s.replaceAll("/", "#/");
    		}
    		
    		if (replaceAll) {
    		
    			s = Regex.sub(body, "s/#$#{out#}/" + s + "/g", '#');
    			
    		} else {
    			
    			s = Regex.sub(body, "s/#$#{out#}/" + s + "/", '#');
    		}
    	}        
        if (s != null) {
        	
        	if (noHTML) {
        	
        		s = s.replaceAll("\\<.*?\\>","");
        		
        	}
            
            if (maxToPrint > 0 && s.length() > maxToPrint) {
                
                s = s.substring(0, maxToPrint) + "...";
                
            }
            
            try {
                pageContext.getOut().print(s);
            } catch(IOException e) {
                throw new RuntimeException(e);
            }
        }
        
        return EVAL_PAGE;
    }	
	
}